import matrix, image, geometry, shader, zb

class Scene:
    def __init__(self):
        self.w2c = matrix.Matrix()
        self.w2c.set_translate(0, 0, 10)
        self.w2c.lookat(0,0,0)
        self.c2s = matrix.Matrix()
        self.c2s.lens(90, 0.1, 10000)
        self.viewport = (0, 0, 512, 512)
        self.window = (-1, -1, 1, 1)
        self.filename_directory = '.'
        self.filename_prefix = 'f'
        self.frame = 0
        self.zbuffer = zb.ZBuffer()
#        self.glbuffer = zb.GLBuffer()
        self.light = []
        self.geometry = []

    def statistics(self):
        self.zbuffer.statistics()
        
    def render(self):
        for i in self.light:
            self.zbuffer.add_light(i)
        for i in self.geometry:
            if (i[3] == None):
                self.zbuffer.add_geometry(i[0], i[1], i[2])
            else:
                self.zbuffer.add_geometry(i[0], i[1], i[2], i[3])
        return self.zbuffer.render()

    def preview(self):
        self.glbuffer = zb.GLBuffer()
        for i in light:
            self.glbuffer.add_light(i)
        for i in geometry:
            if i[3] == None:
                self.glbuffer.add_geometry(i[0], i[1], i[2])
            else:
                self.glbuffer.add_geometry(i[0], i[1], i[2], i[3])
        self.glbuffer.render()
        
    def get_image(self, view='zbuffer'):
        if view == 'zbuffer':
            return self.zbuffer.get_image()
        elif view == 'glbuffer':
            return self.glbuffer.get_image()
        else:
            print 'Unknown image buffer'

    def get_glbuffer_image(self):
        return self.glbuffer.get_image()

    def add_light(self, light):
        self.light.append(light)

    def add_geometry(self, geometry, material, shading_rate,displacement=None):
        self.geometry.append((geometry, material, shading_rate, displacement))

    def set_format(self, format):
        self.zbuffer.set_format(format)

    def scale_viewport(self, scale):
        self.zbuffer.scale_viewport(scale)

    def set_samples(self, supersample_rate):
        self.zbuffer.set_samples(supersample_rate)
        
    def set_filter(self, name, radius):
        self.zbuffer.set_filter(name, radius)
        
    def set_dof(self, focus_dist, scale_factor, focal_length, aperture):
        self.zbuffer.set_dof(focus_dist, scale_factor, focal_length, aperture)

    def checkpoint(self):
        self.zbuffer.checkpoint()

    def material_checkpoint(self, material):
        self.zbuffer.material_checkpoint(material)

    def interpolate_mp(self, state):
        self.zbuffer.interpolate_mp(state)

    def get_filename(self):
        if self.filename_directory[-1] == '/':
            text = "%s%s.%03i.ppm" % (self.filename_directory,
                                      self.filename_prefix, self.frame)
        else:
            text = "%s/%s.%03i.ppm" % (self.filename_directory,
                                       self.filename_prefix, self.frame)
        return text
    
class Geometry:
    def __init__(self):
        self.geometry = geometry.Geometry()

    def quad(self, v0, v1, v2, v3):
        self.geometry.quad(v0, v1, v2, v3)

def Vertex((x,y,z),(u,v),(mx,my,mz)=(-100000,0,0)):
    return geometry.Vertex((x, y, z),(u,v),(mx,my,mz))


class Material:
    def __init__(self):
        self._material = shader.ShaderMaterial()

#    def __getattr__(self, name):
#        print 'material __getattr__: ', name
#        print 'looking for attribute ', name, ' in dict'
#        return self.__dict__[name]
    
    def __setattr__(self, name, value):
        if self.__dict__.has_key('_material'):
            try:
                setattr(self._material, name, value)
                return 0
            except:
                i=1
        self.__dict__[name] = value
        return 0
    

class Light:
    def __init(self):
        print 'Light'

